DoclineUrl = "http://docline.gov/docline/index.cfm";
StandardImportRegEx = [=[(?ms)^(?<ID>[0-9]+).+?\((?<Lender>.+?)\).+?\r\n.*?\r\n((?<Authors>.*?)\r\n)?(?<Article>.*?)\r\n(?<Journal>.*?)\r\n(?<Year>\d{4})\s*(\r\n|.*?;(?<Volume>[^(]*)?(\((?<Issue>[^)]*)?\))?(:(?<Pages>.+?)(?=\.\s*doi:|\.\s*pii:|\.?\s*\r))?)]=]
					  
function LoginLoaded()
	local browser = GetBrowser();
	browser.ScriptErrorsSuppressed = true;

	SetFormValueById("user", "username", FieldTranslator.GetTranslationResults(FieldTranslator, "UserID").Value)
	SetFormValueById("user", "password", FieldTranslator.GetTranslationResults(FieldTranslator, "Password").Value)
	SubmitForm("user")
end

function IsHomePage(browser)	
	local homeButtonImage = GetElementInFrame("doclinemenu", "navHome")
	
	if (homeButtonImage ~= nil) then
		local src = homeButtonImage.GetAttribute(homeButtonImage, "src")
		
		if (string.find(src, "nav-home-on.gif", 0, true) ~= nil) then
			return true
		end
	end
	
	return false
end

function IsFinishedPage(browser)
	if GetForm(nil, "resultForm") ~= nil then
		return true
	elseif GetForm(nil, "backForm") ~= nil then
		return true
	else
		window = GetFrameByName(nil, "editframe")
		
		if window == nil then
			return false
		end
		
		local elementCollection = window.Document.GetElementsByTagName(window.Document, "img")
	
		for i = 0, elementCollection.Count, 1 do	
			element = GetElementByCollectionIndex(elementCollection, i)
			if (element ~= nil and element.GetAttribute(element, "title") == "Full Display") then
				return true
			end
		end
		
		return false				
	end
end

function IsUniqueKeyPage(browser)		
	window = GetFrameByName(nil, "mainframe")
    
    if window == nil then
        return false
    end
    
    local inputCollection = window.Document.GetElementsByTagName(window.Document, "h2")

    for i = 0, inputCollection.Count, 1 do	
        element = GetElementByCollectionIndex(inputCollection, i)
        if (element ~= nil and element.InnerHtml == "Unique Key") then
            return true
        end
    end

    return false
end

function IsAddressForm(browser)
	local window = GetFrameByName(nil, "editframe")
	
	if (window == nil) then
		return false
	end
	
    local elementCollection = window.Document.GetElementsByTagName(window.Document, "h3")

    if (elementCollection == nil or elementCollection.Count == 0) then
		return false
	end
	
	local input
	for i = 0, elementCollection.Count - 1, 1 do
		input = GetElementByCollectionIndex(elementCollection, i)
		
		if (input.InnerHtml == "Delivery Address") then			
			return true
		end
	end
	
	return false
end