require "Docline\\MainDocline";

local Types = {};
Types["System.Object"] = luanet.import_type("System.Object");

function InjectScript(destination, script)
    local objArray = Types["System.Object"][2];
	objArray[0] = script;
	objArray[1] = "JavaScript";
	destination:InvokeScript("execScript", objArray);
end

function OnLoggedIn()
	local navRequestsElement = GetElementInFrame("doclinemenu", "navRequests")
	if navRequestsElement ~= nil then
		ClickObjectByReference(GetParentElement(navRequestsElement))
		NavRequestsClicked()
	end
end

function NavRequestsClicked()
	ClickNavItemByInnerHtml("Borrow")
end

function UniqueKeyFormLoaded()
	ClickNavItemByInnerHtml("Manual")
end

function ManualRequestFormLoaded()
	local editFrame = GetFrameByName(nil, "editframe")
	
	local formCollection = editFrame.Document.GetElementsByTagName(editFrame.Document, "FORM")
	if formCollection.Count == 1 then
		local requestForm = GetElementByCollectionIndex(formCollection, 0)
		
		if requestForm ~= nil then
		
			-- Title
			local currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "Title").Value
			if(currentValue ~= nil) then
				SetFormValue(requestForm, "TITLE", currentValue)
			end
			
			-- Part Title
			local currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "Article").Value
			if(currentValue ~= nil) then
				SetFormValue(requestForm, "PART_TITLE", currentValue)
			end
			
			-- Journal Author
			local currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "JournalAuthor").Value
			if(currentValue ~= nil) then
				SetFormValue(requestForm, "AUED", currentValue)
			end
			
			-- Part Author
			local currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "Author").Value
			if(currentValue ~= nil) then
				SetFormValue(requestForm, "PART_AUTHOR", currentValue)
			end
			
			-- Place
			local currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "PubPlace").Value
			if(currentValue ~= nil) then
				SetFormValue(requestForm, "PUB_PLACE", currentValue)
			end
			
			-- Publisher
			local currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "Publisher").Value
			if(currentValue ~= nil) then
				SetFormValue(requestForm, "PUBLISHER", currentValue)
			end
			
			-- Year
			local currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "PubYear").Value
			if(currentValue ~= nil) then
				SetFormValue(requestForm, "PUB_YEAR", currentValue)
			end
			
			-- Volume
			local currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "Volume").Value
			if(currentValue ~= nil) then
				SetFormValue(requestForm, "VOLUME", currentValue)
			end
			
			-- Issue
			local currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "Issue").Value
			if(currentValue ~= nil) then
				SetFormValue(requestForm, "ISSUE", currentValue)
			end
			
			-- Pages
			local currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "Pages").Value
			if(currentValue ~= nil) then
				SetFormValue(requestForm, "PAGES", currentValue)
			end
			
			-- Type
			local currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "Type").Value
			if(currentValue ~= nil) then
				SetFormValue(requestForm, "TYPE", currentValue)
			end
			
			-- ISSN/ISBN
			local currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "Issn").Value
			if(currentValue ~= nil) then
				SetFormValue(requestForm, "ISSN", currentValue)
			end
			
			--Next
            local elementCollection = editFrame.Document:GetElementsByTagName("img");
            local element = nil;
            
            for i = 0, elementCollection.Count - 1, 1 do
                element = GetElementByCollectionIndex(elementCollection, i)
                if element.GetAttribute(element, "title") == "Next" then
                    ClickObjectByReference(element.Parent)
                    HandleManualPageChange()
                    return
                end
            end
		end
	end
end

function RouteFormLoaded()
	-- We will need this later, so I'm going to grab it now so that it will already be cached when I do the SetFormValue calls.
	local routeForm = GetForm(GetFrameByName(nil, "editframe"), "theform")
	
	local currentValue;
    
    currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "RequestForm").Value        
	if (currentValue ~= nil) then
        local requestFormElements = routeForm.All:GetElementsByName("REQUEST_FORM");
        
        for i = 0, requestFormElements.Count - 1, 1 do
            input = GetElementByCollectionIndex(requestFormElements, i)
            
            if (input.GetAttribute(input, "value") == currentValue) then
                ClickObjectByReference(input);               
                break;
            end
        end        
	end
	
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "CopyrightCompliance").Value
	if currentValue ~= nil then
		SetFormValue("theform", "COPYRIGHT_COMPLIANCE", currentValue)
	end
    
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "ServiceLevel").Value
	if currentValue ~= nil then
		SetFormValue("theform", "SERVICE_LEVEL",currentValue )
	end
    
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "AuthorizedBy").Value
	if currentValue ~= nil then
		SetFormValue("theform", "REQUEST_AUTHORIZED_BY", currentValue)
	end
    
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "ReferralReason").Value
	if currentValue ~= nil then
		SetFormValue("theform", "REFERRAL_REASON", currentValue)
	end
    
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "MaxCost").Value
	if currentValue ~= nil then
		SetFormValue("theform", "MAX_COST", currentValue)
	end
	
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "PatronName").Value
	if currentValue ~= nil then
        SetFormValue("theform", "PNAME", currentValue)
    end
	
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "NetworkShippingOption").Value
	if currentValue ~= nil then
		SetFormValue("theform", "DELIVERY_NETWORK", currentValue)
	end
    
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "NLMShippingOption").Value
	if currentValue ~= nil then
		SetFormValue("theform", "DELIVERY_NLM", currentValue)
	end
	
	StartPageWatcher(1000, 0);
end

function AddressFormLoaded()
	StopPageWatcher();
        
    local window = GetFrameByName(nil, "editframe")
	
	if (window == nil) then
		return false
	end

	--Inject a javascript function that invokes the submit function
	local script = "$(document).ready(function () {if (parent.subframe.validateInput(3)) return parent.subframe.dosave(parent.subframe.BORROW_TYPE)});";
    
    InjectScript(window.Document, script);
    	
	window.Document:InvokeScript("PushSelectionHandler");    
end

function Finished()
	StopPageWatcher(); --Ensure the Pages watcher is stopped to prevent looping
	local importFrame = nil
	local importRegex = nil
	local resultFormPage = false
	if GetForm(nil, "resultForm") ~= nil then
		importFrame = GetFrameByName(nil, "editframe")
		resultFormPage = true
	elseif GetForm(nil, "backForm") ~= nil then
		importFrame = GetFrameByName(nil, "mainframe")
		importRegex = [=[(?s:Result:(?<ID>\d+).*?\((?<Lender>.*?)\).*?(Part Author:(?<Authors>.*?\n)){0,1}(Part Title:(?<Article>.*?\n)){0,1}Citation:.*?(?<Year>\d{0,4}).*?;((?<Volume>.*?)\((?<Issue>.*?)\):(?<Pages>.*?\n)){0,1})]=]
	else
		importFrame = GetFrameByName(nil, "editframe")
		importRegex = StandardImportRegEx
	end

	if (importFrame.Document.Body ~= nil) then
		local counter = 0
		while (((importFrame.Document.Body.InnerText == "Working on requests, please wait...") or (importFrame.Document.Body.InnerText == "Working on your request...")) and (counter < 50)) do
			Sleep(100)
			counter = counter + 1
		end
		
		if (counter == 50) then
			return
		end

		if resultFormPage == true then
			if string.find(importFrame.Document.Body.InnerText, "Result:", 0, true) ~= nil then
				importRegex = [=[(?s:Result:(?<ID>\d+).*?\((?<Lender>.*?)\).*?(Title:(?<Title>.*?\n)){0,1}(Author:(?<JournalAuthor>.*?\n)){0,1}(Part Title:(?<Article>.*?\n)){0,1}(Part Author:(?<Authors>.*?\n)){0,1}Citation:(?<Year>\d{0,4});(?<Volume>.*?)\((?<Issue>.*?)\):(?<Pages>.*?\n))]=]
			else
				importRegex = [=[(?mxns)
								 .*?(?<ID>\d*?)\swas\srouted\sto
								 .*?\((?<Lender>.+?)\).*?\r\n
								 (^(?!Title:|(Part\s)?Author:).*?\r\n)*
								 (^Title:\s(?<Title>.+?)\r\n)?
								 (^(?!Title:|(Part\s)?Author:).*?\r\n)*
								 (^(Part\s)?Author:\s(?<Authors>.+?)\r\n)?							  
							  ]=]
			end	
		end
		DoDataImport(importFrame.Document.Body.InnerText, importRegex)
		RegisterPageHandler("custom", "IsFinishedPage", "Finished", true)
	end
end

function ClickNavItemByInnerHtml(html)
	local doclineFrame = GetFrameByName(nil, "doclinemenu")
	if doclineFrame == nil then
		return
	end
	
	for i = 0, doclineFrame.Document.All.Count - 1, 1 do
		element = GetElementByWindowIndex(doclineFrame, i)
		if element.InnerHtml == html then
			ClickObjectByReference(element)
			return
		end
	end
end

function IsManualRequestPage(browser)
	local verifyElement = GetElementInFrame("editframe", "VERIFY")
	
	return verifyElement ~= nil
end

RegisterPageHandler("formExists", "user", "LoginLoaded", false)
RegisterPageHandler("custom", "IsHomePage", "OnLoggedIn", false)
RegisterPageHandler("custom", "IsUniqueKeyPage", "UniqueKeyFormLoaded", false)
RegisterPageHandler("custom", "IsManualRequestPage", "ManualRequestFormLoaded", false)
RegisterPageHandler("formExists", "theform", "RouteFormLoaded", false)
RegisterPageHandler("custom", "IsAddressForm", "AddressFormLoaded", false)
RegisterPageHandler("custom", "IsFinishedPage", "Finished", true)

FieldTranslator = GetFieldTranslator()

Navigate(DoclineUrl);