require "Docline\\MainDocline";

function Finished()
	local importFrame = nil
	local importRegex = nil
	local resultFormPage = false
	if GetForm(nil, "resultForm") ~= nil then
		importFrame = GetFrameByName(nil, "editframe")
		resultFormPage = true
	elseif GetForm(nil, "backForm") ~= nil then
		importFrame = GetFrameByName(nil, "mainframe")
		importRegex = [=[(?s:Result:(?<ID>\d+).*?\((?<Lender>.*?)\).*?(Part Author:(?<Authors>.*?\n)){0,1}(Part Title:(?<Article>.*?\n)){0,1}Citation:.*?(?<Year>\d{0,4}).*?;((?<Volume>.*?)\((?<Issue>.*?)\):(?<Pages>.*?\n)){0,1})]=]
	else
		importFrame = GetFrameByName(nil, "editframe")
		importRegex = StandardImportRegEx
	end	

	if (importFrame.Document.Body ~= nil) then
		local counter = 0
		while (importFrame.Document.Body.InnerText == "Working on requests, please wait..." and counter < 50) do
			Sleep(100)
			counter = counter + 1
		end
		
		if (counter == 50) then
			return
		end

		if resultFormPage == true then
			if string.find(importFrame.Document.Body.InnerText, "Result:", 0, true) ~= nil then
				importRegex = [=[(?s:Result:(?<ID>\d+).*?\((?<Lender>.*?)\).*?(Title:(?<Title>.*?\n)){0,1}(Author:(?<JournalAuthor>.*?\n)){0,1}(Part Title:(?<Article>.*?\n)){0,1}(Part Author:(?<Authors>.*?\n)){0,1}Citation:(?<Year>\d{0,4});(?<Volume>.*?)\((?<Issue>.*?)\):(?<Pages>.*?\n))]=]
			elseif string.find(importFrame.Document.Body.InnerText, "NLM UNIQUE ID:", 0, true) ~= nil then
				importRegex = [=[(?mxns)
								 .*?(?<ID>\d*?)\swas\srouted\sto
								 .*?\((?<Lender>.+?)\).*?\r\n
								 (^(?!Title:|(Part\s)?Author:).*?\r\n)*
								 (^Title:\s(?<Title>.+?)\r\n)?
								 (^(?!Title:|(Part\s)?Author:).*?\r\n)*
								 (^(Part\s)?Author:\s(?<Authors>.+?)\r\n)?							  
							  ]=]
			else
				importRegex = StandardImportRegEx
			end	
		end
		DoDataImport(importFrame.Document.Body.InnerText, importRegex)
		RegisterPageHandler("custom", "IsFinishedPage", "Finished", true)
	end
end
	

RegisterPageHandler("formExists", "user", "LoginLoaded", false)
RegisterPageHandler("custom", "IsFinishedPage", "Finished", true)

FieldTranslator = GetFieldTranslator()

Navigate(DoclineUrl);